<template>
    <div class="app">
        <v-card class="vuety" max-width="1150px" min-height="600px" style="margin-left: 12%">
            <v-card-title class="bee-gray">
                <v-row justify="center">
                    <v-col cols="12">
                        <v-row align="center">
                            <v-col cols="3">
                                <a @click="$router.go(-1)">
                                    <img width="70px" src="~@/assets/icons/regresar.svg" alt srcset />
                                </a>
                            </v-col>
                            <v-col cols="2">
                                <h5 class="titleBack">Regresar</h5>
                            </v-col>
                        </v-row>
                    </v-col></v-row
                >
                <v-spacer></v-spacer>
            </v-card-title>

            <div class="d-flex black" style="width:100%; position: relative; margin-top:-220px;">
                <h1 class="ml-10 white--text">NEGOCIOS CON SERVICIO DELIVERY</h1>
                <v-spacer></v-spacer>
            </div>
            <div class="d-flex" style="width:100%;">
                <v-row no-gutters align="center" style="height:250px;" class="bee-gray">
                    <v-col cols="1">
                        <v-spacer></v-spacer>
                    </v-col>
                    <v-col cols="6" class="d-flex" style="height:50px;"> <h3 style="margin:auto;">NEGOCIOS</h3></v-col>
                    <v-col cols="4">
                        <v-overflow-btn
                            :items="restaurants"
                            height="50px"
                            item-text="name"
                            :return-object="true"
                            @change="selectorChanged"
                            :value="restaurants.length ? restaurants[0] : null"
                            class="overbtn"
                        ></v-overflow-btn>
                    </v-col>
                    <v-col cols="4">
                        <v-text-field
                            v-model="search"
                            append-icon="mdi-magnify"
                            label="Search"
                            single-line
                            hide-details
                            color="black"
                            style="
                            max-width: 600px;
                            padding-left: 10px;
                            padding-right: 20px;
                            text-justify: distribute-all-lines;
                            background-color: #FFFFFF;"
                            class="searchAuto"
                        >
                        </v-text-field>
                    </v-col>
                </v-row>
            </div>
            <v-data-table
                :headers="headers"
                :items="menusOfSelected"
                :search="search"
                :item-key="menusOfSelected.id"
                style="position: relative; margin-top:-220px;"
            >
                <template v-slot:no-data>
                    <v-alert :value="true" color="error" icon="warning">
                        No se encontro contenido para mostrar por el momento.
                    </v-alert>
                </template>
                <template v-slot:item="row">
                    <tr style="border-top:none;">
                        <td>{{ row.item.name }}</td>
                        <td>{{ row.item.lastUpdated.toDate().toLocaleString() }}</td>
                        <td>
                            <v-btn
                                icon
                                :to="{ name: 'RESTAURANTINFO', params: { id: row.item.id } }"
                                style="width: 10px; height: 10px;"
                            >
                                <HexButton class="hexbtn">
                                    <v-icon>mdi-file-edit-outline</v-icon>
                                </HexButton>
                            </v-btn>
                        </td>
                    </tr>
                </template>
            </v-data-table>
        </v-card>
    </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { Restaurant } from '@/model/Restaurant';
import { namespace } from 'vuex-class';
import HexButton from '@/components/commons/HexButton.vue';
import { Menu } from '@/model/menu/Menu';

const restaurantStore = namespace('RestaurantModule');

@Component({
    components: {
        HexButton
    }
})
export default class DeliveryRestaurants extends Vue {
    @restaurantStore.State
    restaurants!: Restaurant[];
    selectedRestaurant: Restaurant | null = null;

    search = '';
    headers = [
        {
            text: 'CATÁLOGO',
            align: 'center',
            sortable: true,
            value: 'name'
        },
        { text: 'ULTIMA ACTUALIZACIÒN', align: 'center', sortable: false, value: 'lastUpdate' },
        { text: 'EDITAR', align: 'center', sortable: false, value: 'id' }
    ];

    selectorChanged(e: Restaurant) {
        this.selectedRestaurant = e;
    }
    get menusOfSelected(): Menu[] {
        return this.selectedRestaurant == null ? [] : this.selectedRestaurant.menus;
    }
    mounted() {
        if (this.restaurants.length) {
            this.selectedRestaurant = this.restaurants[0];
        }
    }
}
</script>

<style scoped></style>
